local mod = ...



-- Villager need -------------------------------------------------------------------------------------
if not foundation.isModLoaded("9475b42e-f880-4787-9b07-bec720fc90b6") and not foundation.isModLoaded("8d55ee80-e30c-42e3-bf05-1b310d36985f") then
    -- Do not add the need if the old Street Performers, or the Entertainment mod, are loaded

    mod:overrideAsset({
        Id = "COMMONER", -- This is inherited by all higher statuses automatically
        AssetVillagerNeedList = {
            Action = "APPEND", "NEED_ENTERTAINMENT" -- the need is defined in Common Resources mod
        }
    })

    mod:log("No other entertainment mods found, adding entertainment need.")

else

    mod:log("Other entertainment mods found, skipping the entertainment need.")

end



-- Building: Entertainment -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_PUBLIC_LOUNGE",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_VISIT",
    TimeInLounge = 15,
})

mod:registerAsset({
	DataType = "BUILDING",
	Id = "BUILDING_ENTERTAINMENT",
	Name = "BUILDING_ENTERTAINMENT_NAME",
	Description = "BUILDING_ENTERTAINMENT_DESC",
	BuildingType = "SERVICE",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_VISIT",
    AssetMiniatureBuildingPart = "BUILDING_PART_ENTERTAINMENT_JUGGLER",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_ENTERTAINMENT1_NAME",
			BuildingPartList = {
				"BUILDING_PART_ENTERTAINMENT_JUGGLER",
				"BUILDING_PART_ENTERTAINMENT_FORTUNETELLER",
				"BUILDING_PART_ENTERTAINMENT_FIGHTERRING",
				"BUILDING_PART_ENTERTAINMENT_TRAINEDBEAR",
			},
		},
    },
	VillagerRequired = { Status = "COMMONER", Quantity = 1 },
	IsEditable = true,
	MaterialSetList = {
		{ SetName = "FAIRE_RED_WHITE_NAME",		MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_BLUE_WHITE_NAME", 	MaterialList = { "CLOTH_BLUE_MATERIAL", 	"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_GREEN_WHITE_NAME", 	MaterialList = { "CLOTH_GREEN_MATERIAL", 	"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_PURPLE_WHITE_NAME", 	MaterialList = { "CLOTH_PURPLE_MATERIAL", 	"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_YELLOW_WHITE_NAME", 	MaterialList = { "CLOTH_YELLOW_MATERIAL", 	"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_BLACK_WHITE_NAME",	MaterialList = { "CLOTH_BLACK_MATERIAL", 	"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_RED_BLACK_NAME", 	MaterialList = { "CLOTH_RED_MATERIAL",		"CLOTH_BLACK_MATERIAL" 	} },
		{ SetName = "FAIRE_BLUE_BLACK_NAME", 	MaterialList = { "CLOTH_BLUE_MATERIAL", 	"CLOTH_BLACK_MATERIAL" 	} },
		{ SetName = "FAIRE_GREEN_BLACK_NAME", 	MaterialList = { "CLOTH_GREEN_MATERIAL", 	"CLOTH_BLACK_MATERIAL" 	} },
		{ SetName = "FAIRE_PURPLE_BLACK_NAME", 	MaterialList = { "CLOTH_PURPLE_MATERIAL", 	"CLOTH_BLACK_MATERIAL" 	} },
		{ SetName = "FAIRE_YELLOW_BLACK_NAME", 	MaterialList = { "CLOTH_YELLOW_MATERIAL", 	"CLOTH_BLACK_MATERIAL" 	} },
		{ SetName = "FAIRE_WHITE_BLACK_NAME", 	MaterialList = { "CLOTH_WHITE_MATERIAL", 	"CLOTH_BLACK_MATERIAL" 	} },
		{ SetName = "FAIRE_RED_BLUE_NAME", 		MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_BLUE_MATERIAL" 	} },
		{ SetName = "FAIRE_RED_GREEN_NAME", 	MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_GREEN_MATERIAL" 	} },
		{ SetName = "FAIRE_RED_PURPLE_NAME", 	MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_PURPLE_MATERIAL" } },
		{ SetName = "FAIRE_RED_YELLOW_NAME", 	MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_YELLOW_MATERIAL" } },
		{ SetName = "FAIRE_RED_GREY_NAME", 		MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_GREY_MATERIAL" 	} },
		{ SetName = "FAIRE_BLUE_GREEN_NAME", 	MaterialList = { "CLOTH_BLUE_MATERIAL",		"CLOTH_GREEN_MATERIAL" 	} },
		{ SetName = "FAIRE_BLUE_PURPLE_NAME", 	MaterialList = { "CLOTH_BLUE_MATERIAL", 	"CLOTH_PURPLE_MATERIAL" } },
		{ SetName = "FAIRE_BLUE_YELLOW_NAME", 	MaterialList = { "CLOTH_BLUE_MATERIAL", 	"CLOTH_YELLOW_MATERIAL" } },
		{ SetName = "FAIRE_BLUE_GREY_NAME", 	MaterialList = { "CLOTH_BLUE_MATERIAL", 	"CLOTH_GREY_MATERIAL" 	} },
		{ SetName = "FAIRE_GREEN_PURPLE_NAME", 	MaterialList = { "CLOTH_GREEN_MATERIAL", 	"CLOTH_PURPLE_MATERIAL" } },
		{ SetName = "FAIRE_GREEN_YELLOW_NAME", 	MaterialList = { "CLOTH_GREEN_MATERIAL", 	"CLOTH_YELLOW_MATERIAL" } },
		{ SetName = "FAIRE_GREEN_BROWN_NAME", 	MaterialList = { "CLOTH_BROWN_MATERIAL", 	"CLOTH_GREEN_MATERIAL" 	} },
		{ SetName = "FAIRE_GREEN_GREY_NAME", 	MaterialList = { "CLOTH_GREY_MATERIAL", 	"CLOTH_GREEN_MATERIAL" 	} },
		{ SetName = "FAIRE_PURPLE_YELLOW_NAME", MaterialList = { "CLOTH_PURPLE_MATERIAL", 	"CLOTH_YELLOW_MATERIAL" } },
		{ SetName = "FAIRE_PURPLE_GREY_NAME", 	MaterialList = { "CLOTH_PURPLE_MATERIAL", 	"CLOTH_GREY_MATERIAL" 	} },
		{ SetName = "FAIRE_RED_NAME", 			MaterialList = { "CLOTH_RED_MATERIAL", 		"CLOTH_RED_MATERIAL" 	} },
		{ SetName = "FAIRE_BLUE_NAME", 			MaterialList = { "CLOTH_BLUE_MATERIAL", 	"CLOTH_BLUE_MATERIAL" 	} },
		{ SetName = "FAIRE_GREEN_NAME", 		MaterialList = { "CLOTH_GREEN_MATERIAL", 	"CLOTH_GREEN_MATERIAL" 	} },
		{ SetName = "FAIRE_YELLOW_NAME",		MaterialList = { "CLOTH_YELLOW_MATERIAL", 	"CLOTH_YELLOW_MATERIAL" } },
		{ SetName = "FAIRE_PURPLE_NAME",		MaterialList = { "CLOTH_PURPLE_MATERIAL", 	"CLOTH_PURPLE_MATERIAL" } },
		{ SetName = "FAIRE_BROWN_NAME",			MaterialList = { "CLOTH_BROWN_MATERIAL", 	"CLOTH_BROWN_MATERIAL" 	} },
		{ SetName = "FAIRE_WHITE_NAME", 		MaterialList = { "CLOTH_WHITE_MATERIAL", 	"CLOTH_WHITE_MATERIAL" 	} },
		{ SetName = "FAIRE_GREY_NAME", 			MaterialList = { "CLOTH_GREY_MATERIAL", 	"CLOTH_GREY_MATERIAL"	} },
		{ SetName = "FAIRE_BLACK_NAME", 		MaterialList = { "CLOTH_BLACK_MATERIAL", 	"CLOTH_BLACK_MATERIAL" 	} }
    },
})



mod:overrideAsset({
    Id = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
    IsDescriptionOverride = false,
})