local mod = ...



-- Building Asset Processor
mod:registerAssetProcessor("models/Performer2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/Performer2.fbx/Prefab/Assemblage.Part.001", "PREFAB_ENTERTAINMENT_ASSEMBLAGE1")

mod:registerAssetId("models/Performer2.fbx/Prefab/Ring.Part.001", "PREFAB_ENTERTAINMENT_FIGHTERRING1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Ring.Part.001.Constr", "PREFAB_ENTERTAINMENT_FIGHTERRING1_CONSTR")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001", "PREFAB_ENTERTAINMENT_FIGHTER1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002", "PREFAB_ENTERTAINMENT_FIGHTER2")



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Performer2.fbx/Prefab/Ring.Part.001", { "PLATFORM" })



-- Ground -------------------------------------------------------------------------------------
for i = 1, 8 do
    mod:registerPrefabComponent("models/Performer2.fbx/Prefab/Ring.Part.001/Fence.00" .. i, { DataType = "COMP_GROUNDED" })
end



-- Manual paths for buyer and seller ---------------------------------------------------------------------------------
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_A_1", "PATH_ENTERTAINMENT_FIGHTER1_1_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_A_2", "PATH_ENTERTAINMENT_FIGHTER1_1_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_A_3", "PATH_ENTERTAINMENT_FIGHTER1_1_3")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_A_4", "PATH_ENTERTAINMENT_FIGHTER1_1_4")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_A_5", "PATH_ENTERTAINMENT_FIGHTER1_1_5")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_A_6", "PATH_ENTERTAINMENT_FIGHTER1_1_6")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_C_1", "PATH_ENTERTAINMENT_FIGHTER2_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_C_2", "PATH_ENTERTAINMENT_FIGHTER2_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_C_3", "PATH_ENTERTAINMENT_FIGHTER2_3")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_D_1", "PATH_ENTERTAINMENT_FIGHTER3_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_D_2", "PATH_ENTERTAINMENT_FIGHTER3_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_D_3", "PATH_ENTERTAINMENT_FIGHTER3_3")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_E_1", "PATH_ENTERTAINMENT_FIGHTER4_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_E_2", "PATH_ENTERTAINMENT_FIGHTER4_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_E_3", "PATH_ENTERTAINMENT_FIGHTER4_3")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_F_1", "PATH_ENTERTAINMENT_FIGHTER5_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_F_2", "PATH_ENTERTAINMENT_FIGHTER5_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.001/PATH_F_3", "PATH_ENTERTAINMENT_FIGHTER5_3")

mod:registerPrefabComponent("models/Performer2.fbx/Prefab/Fighter.Part.001", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER1_1_1",
                "PATH_ENTERTAINMENT_FIGHTER1_1_2",
                "PATH_ENTERTAINMENT_FIGHTER1_1_3",
                "PATH_ENTERTAINMENT_FIGHTER1_1_4",
                "PATH_ENTERTAINMENT_FIGHTER1_1_5",
                "PATH_ENTERTAINMENT_FIGHTER1_1_6",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER2_1",
                "PATH_ENTERTAINMENT_FIGHTER2_2",
                "PATH_ENTERTAINMENT_FIGHTER2_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER3_1",
                "PATH_ENTERTAINMENT_FIGHTER3_2",
                "PATH_ENTERTAINMENT_FIGHTER3_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER4_1",
                "PATH_ENTERTAINMENT_FIGHTER4_2",
                "PATH_ENTERTAINMENT_FIGHTER4_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER5_1",
                "PATH_ENTERTAINMENT_FIGHTER5_2",
                "PATH_ENTERTAINMENT_FIGHTER5_3",
            },
        },
    }
})

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_B_1", "PATH_ENTERTAINMENT_FIGHTER2_1_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_B_2", "PATH_ENTERTAINMENT_FIGHTER2_1_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_B_3", "PATH_ENTERTAINMENT_FIGHTER2_1_3")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_B_4", "PATH_ENTERTAINMENT_FIGHTER2_1_4")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_B_5", "PATH_ENTERTAINMENT_FIGHTER2_1_5")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_G_1", "PATH_ENTERTAINMENT_FIGHTER6_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_G_2", "PATH_ENTERTAINMENT_FIGHTER6_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_G_3", "PATH_ENTERTAINMENT_FIGHTER6_3")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_H_1", "PATH_ENTERTAINMENT_FIGHTER7_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_H_2", "PATH_ENTERTAINMENT_FIGHTER7_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_H_3", "PATH_ENTERTAINMENT_FIGHTER7_3")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_I_1", "PATH_ENTERTAINMENT_FIGHTER8_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_I_2", "PATH_ENTERTAINMENT_FIGHTER8_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_I_3", "PATH_ENTERTAINMENT_FIGHTER8_3")

mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_J_1", "PATH_ENTERTAINMENT_FIGHTER9_1")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_J_2", "PATH_ENTERTAINMENT_FIGHTER9_2")
mod:registerAssetId("models/Performer2.fbx/Prefab/Fighter.Part.002/PATH_J_3", "PATH_ENTERTAINMENT_FIGHTER9_3")


mod:registerPrefabComponent("models/Performer2.fbx/Prefab/Fighter.Part.002", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER2_1_1",
                "PATH_ENTERTAINMENT_FIGHTER2_1_2",
                "PATH_ENTERTAINMENT_FIGHTER2_1_3",
                "PATH_ENTERTAINMENT_FIGHTER2_1_4",
                "PATH_ENTERTAINMENT_FIGHTER2_1_5",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER6_1",
                "PATH_ENTERTAINMENT_FIGHTER6_2",
                "PATH_ENTERTAINMENT_FIGHTER6_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER7_1",
                "PATH_ENTERTAINMENT_FIGHTER7_2",
                "PATH_ENTERTAINMENT_FIGHTER7_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER8_1",
                "PATH_ENTERTAINMENT_FIGHTER8_2",
                "PATH_ENTERTAINMENT_FIGHTER8_3",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FIGHTER9_1",
                "PATH_ENTERTAINMENT_FIGHTER9_2",
                "PATH_ENTERTAINMENT_FIGHTER9_3",
            },
        },
    }
})



-- Job: FIGHTER -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_FIGHTER",
	JobName = "JOB_ENTERTAINMENT_FIGHTER_NAME",
	JobDescription = "JOB_ENTERTAINMENT_FIGHTER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_ENTERTAINMENT_FIGHTER",
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		WalkAnimation = "WALKING",
		IdleAnimation = "HAND_ATTACK",
	},
})

mod:overrideAsset({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_FIGHTER",
    },
})

mod:overrideAsset({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_FIGHTER",
    },
})

mod:overrideAsset({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_FIGHTER",
    },
})



-- Building Function: FIGHTER -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_FIGHTER",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_FIGHTER_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = {
        Job = "JOB_ENTERTAINMENT_FIGHTER",
        Behavior = "BEHAVIOR_ENTERTAINMENT_FIGHTER",
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 4,
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Part: Fighting Ring -------------------------------------------------------------------------------------

-- Ring
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_FIGHTERRING1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_FIGHTERRING1",
	},
})

-- Fighter
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_FIGHTER1",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_FIGHTER1",
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_FIGHTER",
})

-- Fighter
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_FIGHTER2",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_FIGHTER2",
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_FIGHTER",
})

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_FIGHTERRING_ASSEMBLAGE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_ENTERTAINMENT_ASSEMBLAGE1" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_FIGHTERRING1", OptionalAttachNodeString = "Attach_Major.002", },
			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_FIGHTER1", OptionalAttachNodeString = "Attach_Major.008", },
			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_FIGHTER2", OptionalAttachNodeString = "Attach_Major.009", },
		},
	},
})

-- Final Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_ENTERTAINMENT_FIGHTERRING",
    Name = "BUILDING_PART_ENTERTAINMENT_FIGHTERRING_NAME",
    Description = "BUILDING_PART_ENTERTAINMENT_FIGHTERRING_DESC",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_ENTERTAINMENT_FIGHTERRING_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { -0.3, 0.5, -16 },
            OrientationOffset = -20.0,
            CameraPitchOffset = 25.0
        },
    },
    ConstructionVisual = "PREFAB_ENTERTAINMENT_FIGHTERRING1_CONSTR",
	BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 5.6, {0.0, 0.0}, 14 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
			},
		},
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
    Capacity = 8,
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 20 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 10 }
        },
        ResourceNeededList = {
            {
                { Resource = "WOOD", Quantity = 20 },
                { Resource = "PLANK", Quantity = 20 },
            },
            {
                { Resource = "WOOLEN_CLOTH", Quantity = 20 },
                { Resource = "TOOL", Quantity = 10 },
            },
        },
    },
})
