local mod = ...



-- Building Asset Processor
mod:registerAssetProcessor("models/Performer3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001", "PREFAB_ENTERTAINMENT_FORTUNETELLER1")
mod:registerAssetId("models/Performer3.fbx/Prefab/Assemblage.Part.001", "PREFAB_ENTERTAINMENT_FORTUNETELLER_ASSEMBLAGE")

mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Male.Front", "PREFAB_ENTERTAINMENT_FORTUNETELLER_MALE_FRONT")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Male.Belt", "PREFAB_ENTERTAINMENT_FORTUNETELLER_MALE_BELT")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Male.Hat", "PREFAB_ENTERTAINMENT_FORTUNETELLER_MALE_HAT")

mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Female.Front", "PREFAB_ENTERTAINMENT_FORTUNETELLER_FEMALE_FRONT")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Female.Belt", "PREFAB_ENTERTAINMENT_FORTUNETELLER_FEMALE_BELT")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Female.Hat", "PREFAB_ENTERTAINMENT_FORTUNETELLER_FEMALE_HAT")



-- Manual paths for buyer and seller ---------------------------------------------------------------------------------
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001/PATH_A_1", "PATH_ENTERTAINMENT_FORTUNETELLER1_1")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001/PATH_A_2", "PATH_ENTERTAINMENT_FORTUNETELLER1_2")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001/PATH_A_3", "PATH_ENTERTAINMENT_FORTUNETELLER1_3")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001/PATH_A_4", "PATH_ENTERTAINMENT_FORTUNETELLER1_4")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001/PATH_B_1", "PATH_ENTERTAINMENT_FORTUNETELLER2_1")
mod:registerAssetId("models/Performer3.fbx/Prefab/Teller.Part.001/PATH_B_2", "PATH_ENTERTAINMENT_FORTUNETELLER2_2")

mod:registerPrefabComponent("models/Performer3.fbx/Prefab/Teller.Part.001", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = {
                "PATH_ENTERTAINMENT_FORTUNETELLER1_1",
                "PATH_ENTERTAINMENT_FORTUNETELLER1_2",
                "PATH_ENTERTAINMENT_FORTUNETELLER1_3",
                "PATH_ENTERTAINMENT_FORTUNETELLER1_4",
            },
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = {
                "PATH_ENTERTAINMENT_FORTUNETELLER2_1",
                "PATH_ENTERTAINMENT_FORTUNETELLER2_2",
            },
        },
    }
})



-- Job: Fortune Teller -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_FORTUNETELLER",
	JobName = "JOB_ENTERTAINMENT_FORTUNETELLER_NAME",
	JobDescription = "JOB_ENTERTAINMENT_FORTUNETELLER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 20.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        FemaleFrontList = {
            "PREFAB_ENTERTAINMENT_FORTUNETELLER_FEMALE_FRONT",
        },
        FemaleHatList = {
            "PREFAB_ENTERTAINMENT_FORTUNETELLER_FEMALE_HAT",
		},
        FemaleBeltList = {
            "PREFAB_ENTERTAINMENT_FORTUNETELLER_FEMALE_BELT",
        },
        MaleFrontList = {
            "PREFAB_ENTERTAINMENT_FORTUNETELLER_MALE_FRONT",
        },
        MaleHatList = {
            "PREFAB_ENTERTAINMENT_FORTUNETELLER_MALE_HAT",
		},
        MaleBeltList = {
            "PREFAB_ENTERTAINMENT_FORTUNETELLER_MALE_BELT",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "BREWING",
	},
})

mod:overrideAsset({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_FORTUNETELLER",
    },
})

mod:overrideAsset({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_FORTUNETELLER",
    },
})

mod:overrideAsset({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_FORTUNETELLER",
    },
})



-- Building Function: Fortune Teller -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_FORTUNETELLER",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_FORTUNETELLER_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = {
        Job = "JOB_ENTERTAINMENT_FORTUNETELLER",
        Behavior = "BEHAVIOR_WORK",
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 5,
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Part: Fortune Teller's Tent -------------------------------------------------------------------------------------

-- Teller's Path
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER_SELLER",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_FORTUNETELLER1",
	},
    AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_FORTUNETELLER",
})

-- Assemblage
mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER_ASSEMBLAGE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_ENTERTAINMENT_FORTUNETELLER_ASSEMBLAGE" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER_SELLER", OptionalAttachNodeString = "Attach_Major.001", },
			{ BuildingPart = "FORTUNE_TELLER_TENT_PART", OptionalAttachNodeString = "Attach_Major.002", }, -- from Medieval Faire mod
			{ BuildingPart = "FORTUNE_TELLER_TABLE_PART", OptionalAttachNodeString = "Attach_Major.003", }, -- from Medieval Faire mod
		},
	},
})

-- Final Part
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER",
    Name = "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER_NAME",
    Description = "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER_DESC",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
        RandomPartList = {
            "BUILDING_PART_ENTERTAINMENT_FORTUNETELLER_ASSEMBLAGE",
        },
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { -0.25, 2.5, -16 },
            OrientationOffset = -20.0,
            CameraPitchOffset = 0.0
        },
    },
	BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 3.0, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true },
			},
		},
	},
    Capacity = 1,
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 10 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 5 }
        },
        ResourceNeededList = {
            {
                { Resource = "WOOLEN_CLOTH", Quantity = 30 },
                { Resource = "TOOL", Quantity = 10 },
            },
        },
    },
})

